VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3270
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6120
   LinkTopic       =   "Form1"
   ScaleHeight     =   3270
   ScaleWidth      =   6120
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   2895
      Left            =   0
      ScaleHeight     =   2835
      ScaleWidth      =   5475
      TabIndex        =   0
      Top             =   0
      Width           =   5535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Const WINDING = 2

' Draw a gradient-filled polygon.
Private Sub DrawPolygon()
Const PI = 3.14159265
Const NUM_POINTS = 8
Const NUM_PTS = 2 * NUM_POINTS

Dim pts(1 To NUM_PTS) As POINTAPI
Dim i As Integer
Dim cx As Single
Dim cy As Single
Dim theta As Single
Dim dtheta As Single
Dim rx1 As Single
Dim rx2 As Single
Dim ry1 As Single
Dim ry2 As Single
Dim hRgn As Long
Dim clr As Single
Dim dclr As Single

    ' API functions work in pixels.
    Picture1.Move 0, 0, ScaleWidth, ScaleHeight
    Picture1.ScaleMode = vbPixels
    Picture1.AutoRedraw = True

    If Picture1.ScaleHeight < 1 Then Exit Sub
    If Picture1.ScaleWidth < 1 Then Exit Sub

    ' Set the points' coordinates.
    cx = Picture1.ScaleWidth / 2
    cy = Picture1.ScaleHeight / 2
    rx1 = Picture1.ScaleWidth * 0.49
    rx2 = Picture1.ScaleWidth * 0.25
    ry1 = Picture1.ScaleHeight * 0.49
    ry2 = Picture1.ScaleHeight * 0.25
    dtheta = 2 * PI / NUM_PTS
    theta = 0
    i = 1
    Do While i < NUM_PTS
        pts(i).X = cx + rx1 * Cos(theta)
        pts(i).Y = cy + ry1 * Sin(theta)
        theta = theta + dtheta
        i = i + 1

        pts(i).X = cx + rx2 * Cos(theta)
        pts(i).Y = cy + ry2 * Sin(theta)
        theta = theta + dtheta
        i = i + 1
    Loop

    ' Confine the PictureBox to this polygon.
    hRgn = CreatePolygonRgn(pts(1), NUM_PTS, WINDING)
    SetWindowRgn Picture1.hWnd, hRgn, True

    ' Draw a color gradient through the picture.
    clr = 256
    dclr = -255 / Picture1.ScaleHeight
    For i = 0 To Picture1.ScaleHeight
        Picture1.Line (0, i)-(Picture1.ScaleWidth, i), RGB(0, clr, 0)
        clr = clr + dclr
    Next i
End Sub

' Redraw the polygon.
Private Sub Form_Resize()
    DrawPolygon
End Sub


